import { W3 } from './';
/**
 * Base contract for all Soltsice contracts
 */
export declare class SoltsiceContract {
    static silent: boolean;
    transactionHash: Promise<string>;
    w3: W3;
    protected _Contract: any;
    /** Truffle-contract instance. Use it if Soltsice doesn't support some features yet */
    protected _instance: any;
    protected _instancePromise: Promise<any>;
    protected _sendParams: W3.TX.TxParams;
    protected static newDataImpl(w3?: W3, tokenArtifacts?: any, constructorParams?: W3.TX.ContractDataType[]): string;
    protected constructor(web3?: W3, tokenArtifacts?: any, constructorParams?: W3.TX.ContractDataType[], deploymentParams?: string | W3.TX.TxParams | object, link?: SoltsiceContract[]);
    readonly address: string;
    readonly instance: any;
    /** Default tx params for sending transactions. */
    readonly sendTxParams: W3.TX.TxParams;
    /** Send a transaction to the fallback function */
    sendTransaction(txParams?: W3.TX.TxParams): Promise<W3.TX.TransactionResult>;
    parseLogs(logs: W3.Log[]): Promise<W3.Log[]>;
    parseReceipt(receipt: W3.TransactionReceipt): Promise<W3.Log[]>;
    /** Get transaction result by hash. Returns receipt + parsed logs. */
    getTransactionResult(txHash: string): Promise<W3.TX.TransactionResult>;
    waitTransactionReceipt(hashString: string): Promise<W3.TX.TransactionResult>;
    newFilter(fromBlock: number, toBlock?: number): Promise<number>;
    uninstallFilter(filter: number): Promise<boolean>;
    getFilterChanges(filter: number): Promise<W3.Log[]>;
    getFilterLogs(filter: number): Promise<W3.Log[]>;
    getLogs(fromBlock: number, toBlock?: number): Promise<W3.Log[]>;
}
