"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var contract = require("truffle-contract");
var _1 = require("./");
var SolidityCoder = require("web3/lib/solidity/coder.js");
/**
 * Base contract for all Soltsice contracts
 */
var SoltsiceContract = /** @class */ (function () {
    function SoltsiceContract(web3, tokenArtifacts, constructorParams, deploymentParams, link) {
        var _this = this;
        if (!web3) {
            web3 = _1.W3.default;
        }
        this.w3 = web3;
        if (typeof deploymentParams === 'string' &&
            deploymentParams !== '' &&
            !_1.W3.isValidAddress(deploymentParams)) {
            throw 'Invalid deployed contract address';
        }
        this._Contract = contract(tokenArtifacts);
        this._Contract.setProvider(web3.currentProvider);
        function instanceOfTxParams(obj) {
            return 'from' in obj && 'gas' in obj && 'gasPrice' in obj && 'value' in obj;
        }
        var linkage = new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var network;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(link && link.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.w3.networkId];
                    case 1:
                        network = +(_a.sent());
                        this._Contract.setNetwork(network);
                        link.forEach(function (element) { return __awaiter(_this, void 0, void 0, function () {
                            var inst;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, element._instancePromise];
                                    case 1:
                                        inst = _a.sent();
                                        this._Contract.link(element._Contract.contractName, inst.address);
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        resolve(true);
                        return [3 /*break*/, 3];
                    case 2:
                        resolve(true);
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        var instance = new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _a, useDeployed, useExisting;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, linkage];
                    case 1:
                        _b.sent();
                        if (!this.w3.defaultAccount) return [3 /*break*/, 3];
                        this._sendParams = _1.W3.TX.txParamsDefaultSend(this.w3.defaultAccount);
                        return [4 /*yield*/, this.w3.networkId];
                    case 2:
                        if ((_b.sent()) !== '1') {
                            this._sendParams.gasPrice = 20000000000; // 20 Gwei, tests are too slow with the 2 Gwei default one
                        }
                        _b.label = 3;
                    case 3:
                        useDeployed = function () { return __awaiter(_this, void 0, void 0, function () {
                            var network;
                            var _this = this;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this.w3.networkId];
                                    case 1:
                                        network = +(_a.sent());
                                        this._Contract.setNetwork(network);
                                        this._Contract
                                            .deployed()
                                            .then(function (inst) {
                                            _this.transactionHash = inst.transactionHash;
                                            if (!SoltsiceContract.silent) {
                                                console.log('SOLTSICE: USING DEPLOYED CONTRACT', _this.constructor.name, ' at ', deploymentParams);
                                            }
                                            resolve(inst);
                                        })
                                            .catch(function (err) {
                                            reject(err);
                                        });
                                        return [2 /*return*/];
                                }
                            });
                        }); };
                        useExisting = function (address) {
                            if (!SoltsiceContract.silent) {
                                console.log('SOLTSICE: USING EXISTING CONTRACT', _this.constructor.name, ' at ', deploymentParams);
                            }
                            _this._Contract
                                .at(address)
                                .then(function (inst) {
                                _this.transactionHash = inst.transactionHash;
                                resolve(inst);
                            })
                                .catch(function (err) {
                                reject(err);
                            });
                        };
                        if (!deploymentParams) {
                            useDeployed();
                        }
                        else if (typeof deploymentParams === 'string') {
                            useExisting(deploymentParams);
                        }
                        else if (instanceOfTxParams(deploymentParams)) {
                            (_a = this._Contract).new.apply(_a, __spread(constructorParams, [deploymentParams])).then(function (inst) {
                                if (!SoltsiceContract.silent) {
                                    console.log('SOLTSICE: DEPLOYED NEW CONTRACT ', _this.constructor.name, ' at ', inst.address);
                                }
                                _this.transactionHash = inst.transactionHash;
                                resolve(inst);
                            })
                                .catch(function (err) {
                                reject(err);
                            });
                        }
                        else if (deploymentParams.address && typeof deploymentParams.address === 'string') {
                            // support any object with address property
                            useExisting(deploymentParams.address);
                        }
                        return [2 /*return*/];
                }
            });
        }); });
        this._instancePromise = instance.then(function (i) {
            _this._instance = i;
            return i;
        });
    }
    SoltsiceContract.newDataImpl = function (w3, tokenArtifacts, constructorParams) {
        var _a;
        if (!w3) {
            w3 = _1.W3.default;
        }
        var ct = w3.web3.eth.contract(tokenArtifacts.abi);
        var data = (_a = ct.new).getData.apply(_a, __spread(constructorParams, [{ data: tokenArtifacts.bytecode }]));
        return data;
    };
    Object.defineProperty(SoltsiceContract.prototype, "address", {
        get: function () {
            return this._instance.address;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SoltsiceContract.prototype, "instance", {
        get: function () {
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SoltsiceContract.prototype, "sendTxParams", {
        /** Default tx params for sending transactions. */
        get: function () {
            return this._sendParams;
        },
        enumerable: true,
        configurable: true
    });
    /** Send a transaction to the fallback function */
    SoltsiceContract.prototype.sendTransaction = function (txParams) {
        return __awaiter(this, void 0, void 0, function () {
            var instance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        txParams = txParams || this._sendParams;
                        if (!txParams) {
                            throw new Error('Default tx parameters are not set.');
                        }
                        return [4 /*yield*/, this.instance];
                    case 1:
                        instance = _a.sent();
                        return [2 /*return*/, instance.sendTransaction(txParams)];
                }
            });
        });
    };
    SoltsiceContract.prototype.parseLogs = function (logs) {
        return __awaiter(this, void 0, void 0, function () {
            var web3, inst, abi;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        web3 = this.w3;
                        return [4 /*yield*/, this.instance];
                    case 1:
                        inst = _a.sent();
                        abi = inst.abi;
                        return [2 /*return*/, logs
                                .map(function (log) {
                                var logABI = null;
                                for (var i = 0; i < abi.length; i++) {
                                    var item = abi[i];
                                    if (item.type !== 'event') {
                                        continue;
                                    }
                                    // tslint:disable-next-line:max-line-length
                                    var signature = item.name +
                                        '(' +
                                        item.inputs
                                            .map(function (input) {
                                            return input.type;
                                        })
                                            .join(',') +
                                        ')';
                                    var hash = _this.w3.web3.sha3(signature);
                                    if (hash === log.topics[0]) {
                                        logABI = item;
                                        break;
                                    }
                                }
                                if (logABI != null) {
                                    // Adapted from truffle-contract
                                    var copy_1 = Object.assign({}, log);
                                    var decode = function (fullABI, indexed, data) {
                                        var _inputs = fullABI.inputs.filter(function (input) {
                                            return input.indexed === indexed;
                                        });
                                        var partial = {
                                            inputs: _inputs,
                                            name: fullABI.name,
                                            type: fullABI.type,
                                            anonymous: fullABI.anonymous
                                        };
                                        var types = partial.inputs.map(function (x) { return x.type; });
                                        var params = SolidityCoder.decodeParams(types, data);
                                        var temp = {};
                                        for (var index = 0; index < _inputs.length; index++) {
                                            temp[_inputs[index].name] = params[index];
                                        }
                                        return temp;
                                    };
                                    var argTopics = logABI.anonymous ? copy_1.topics : copy_1.topics.slice(1);
                                    var indexedData = argTopics
                                        .map(function (topics) {
                                        return topics.slice(2);
                                    })
                                        .join('');
                                    // tslint:disable-next-line:max-line-length
                                    var indexedParams_1 = decode(logABI, true, indexedData);
                                    var notIndexedData = copy_1.data.replace('0x', '');
                                    // tslint:disable-next-line:max-line-length
                                    var notIndexedParams_1 = decode(logABI, false, notIndexedData);
                                    copy_1.event = logABI.name;
                                    copy_1.args = logABI.inputs.reduce(function (acc, current) {
                                        var val = indexedParams_1[current.name];
                                        if (val === undefined) {
                                            val = notIndexedParams_1[current.name];
                                        }
                                        acc[current.name] = val;
                                        return acc;
                                    }, {});
                                    Object.keys(copy_1.args).forEach(function (key) {
                                        var val = copy_1.args[key];
                                        // We have BN. Convert it to BigNumber
                                        if (val.constructor.isBN) {
                                            copy_1.args[key] = web3.toBigNumber('0x' + val.toString(16));
                                        }
                                    });
                                    delete copy_1.data;
                                    delete copy_1.topics;
                                    return copy_1;
                                }
                                else {
                                    return undefined;
                                }
                            })
                                .filter(function (d) { return d; })];
                }
            });
        });
    };
    SoltsiceContract.prototype.parseReceipt = function (receipt) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!receipt.logs) {
                    return [2 /*return*/, []];
                }
                return [2 /*return*/, this.parseLogs(receipt.logs)];
            });
        });
    };
    /** Get transaction result by hash. Returns receipt + parsed logs. */
    SoltsiceContract.prototype.getTransactionResult = function (txHash) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.w3.web3.eth.getTransactionReceipt(txHash, function (err, receipt) { return __awaiter(_this, void 0, void 0, function () {
                var result, _a, e_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!err) return [3 /*break*/, 1];
                            reject(err);
                            return [3 /*break*/, 5];
                        case 1:
                            if (!!receipt) return [3 /*break*/, 2];
                            reject('Receipt is falsy, transaction does not exists or was not mined yet.');
                            return [3 /*break*/, 5];
                        case 2:
                            _b.trys.push([2, 4, , 5]);
                            result = {};
                            result.tx = receipt.transactionHash;
                            result.receipt = receipt;
                            _a = result;
                            return [4 /*yield*/, this.parseReceipt(receipt)];
                        case 3:
                            _a.logs = _b.sent();
                            resolve(result);
                            return [3 /*break*/, 5];
                        case 4:
                            e_1 = _b.sent();
                            reject({ error: e_1, description: 'Unhandled exception' });
                            return [3 /*break*/, 5];
                        case 5: return [2 /*return*/];
                    }
                });
            }); });
        });
    };
    SoltsiceContract.prototype.waitTransactionReceipt = function (hashString) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (accept, reject) {
                        var timeout = 240000;
                        var start = new Date().getTime();
                        var makeAttempt = function () {
                            _this.w3.web3.eth.getTransactionReceipt(hashString, function (err, receipt) { return __awaiter(_this, void 0, void 0, function () {
                                var result, _a, e_2;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (err) {
                                                return [2 /*return*/, reject(err)];
                                            }
                                            if (!(receipt != null)) return [3 /*break*/, 4];
                                            _b.label = 1;
                                        case 1:
                                            _b.trys.push([1, 3, , 4]);
                                            result = {};
                                            result.tx = receipt.transactionHash;
                                            result.receipt = receipt;
                                            _a = result;
                                            return [4 /*yield*/, this.parseReceipt(receipt)];
                                        case 2:
                                            _a.logs = _b.sent();
                                            accept(result);
                                            return [3 /*break*/, 4];
                                        case 3:
                                            e_2 = _b.sent();
                                            reject({ error: e_2, description: 'Unhandled exception' });
                                            return [3 /*break*/, 4];
                                        case 4:
                                            if (timeout > 0 && new Date().getTime() - start > timeout) {
                                                return [2 /*return*/, reject(new Error('Transaction ' + hashString + " wasn't processed in " + timeout / 1000 + ' seconds!'))];
                                            }
                                            setTimeout(makeAttempt, 1000);
                                            return [2 /*return*/];
                                    }
                                });
                            }); });
                        };
                        makeAttempt();
                    })];
            });
        });
    };
    SoltsiceContract.prototype.newFilter = function (fromBlock, toBlock) {
        return __awaiter(this, void 0, void 0, function () {
            var toBlock1, id, filter, _a, _b, _c, _d;
            var _this = this;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        toBlock1 = toBlock ? this.w3.fromDecimal(toBlock) : 'latest';
                        id = 'W3:' + _1.W3.getNextCounter();
                        _b = (_a = this.w3).sendRPC;
                        _c = {
                            jsonrpc: '2.0',
                            method: 'eth_newFilter'
                        };
                        _d = {
                            fromBlock: this.w3.fromDecimal(fromBlock),
                            toBlock: toBlock1
                        };
                        return [4 /*yield*/, this.address];
                    case 1: return [4 /*yield*/, _b.apply(_a, [(_c.params = [
                                (_d.address = _e.sent(),
                                    _d)
                            ],
                                _c.id = id,
                                _c)])
                            .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (r.error) {
                                    throw 'Cannot set filter';
                                }
                                return [2 /*return*/, r.result];
                            });
                        }); })];
                    case 2:
                        filter = _e.sent();
                        return [2 /*return*/, this.w3.toBigNumber(filter).toNumber()]; // filter
                }
            });
        });
    };
    SoltsiceContract.prototype.uninstallFilter = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var id, ret;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = 'W3:' + _1.W3.getNextCounter();
                        return [4 /*yield*/, this.w3
                                .sendRPC({
                                jsonrpc: '2.0',
                                method: 'eth_uninstallFilter',
                                params: [this.w3.fromDecimal(filter)],
                                id: id
                            })
                                .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    if (r.error) {
                                        throw 'Cannot uninstall filter';
                                    }
                                    return [2 /*return*/, r.result];
                                });
                            }); })];
                    case 1:
                        ret = _a.sent();
                        return [2 /*return*/, ret];
                }
            });
        });
    };
    SoltsiceContract.prototype.getFilterChanges = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var id, logs;
            var _this = this;
            return __generator(this, function (_a) {
                id = 'W3:' + _1.W3.getNextCounter();
                logs = this.w3
                    .sendRPC({
                    jsonrpc: '2.0',
                    method: 'eth_getFilterChanges',
                    params: [this.w3.fromDecimal(filter)],
                    id: id
                })
                    .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                    var parsed;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (r.error) {
                                    console.log('FILTER ERR: ', r);
                                    return [2 /*return*/, []];
                                }
                                console.log('FILTER: ', r);
                                return [4 /*yield*/, this.parseLogs(r.result)];
                            case 1:
                                parsed = _a.sent();
                                return [2 /*return*/, parsed];
                        }
                    });
                }); });
                return [2 /*return*/, logs];
            });
        });
    };
    SoltsiceContract.prototype.getFilterLogs = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var id, logs;
            var _this = this;
            return __generator(this, function (_a) {
                id = 'W3:' + _1.W3.getNextCounter();
                logs = this.w3
                    .sendRPC({
                    jsonrpc: '2.0',
                    method: 'eth_getFilterLogs',
                    params: [this.w3.fromDecimal(filter)],
                    id: id
                })
                    .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                    var parsed;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (r.error) {
                                    return [2 /*return*/, []];
                                }
                                return [4 /*yield*/, this.parseLogs(r.result)];
                            case 1:
                                parsed = _a.sent();
                                return [2 /*return*/, parsed];
                        }
                    });
                }); });
                return [2 /*return*/, logs];
            });
        });
    };
    SoltsiceContract.prototype.getLogs = function (fromBlock, toBlock) {
        return __awaiter(this, void 0, void 0, function () {
            var toBlock1;
            var _this = this;
            return __generator(this, function (_a) {
                toBlock1 = toBlock ? this.w3.fromDecimal(toBlock) : 'latest';
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.instance];
                                case 1:
                                    (_a.sent()).allEvents({ fromBlock: fromBlock, toBlock: toBlock1 }).get(function (error, log) {
                                        if (error) {
                                            reject(error);
                                        }
                                        resolve(log);
                                    });
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    SoltsiceContract.silent = false;
    return SoltsiceContract;
}());
exports.SoltsiceContract = SoltsiceContract;
//# sourceMappingURL=SoltsiceContract.js.map