"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var W3_1 = require("./W3");
var TestRPC = /** @class */ (function () {
    /**
     *
     */
    function TestRPC(w3) {
        this.w3 = w3 || new W3_1.W3();
    }
    /**
     * Snapshot the state of the blockchain at the current block. Takes no parameters.
     * Returns the integer id of the snapshot created.
     */
    TestRPC.prototype.snapshot = function () {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.isTestRPC];
                    case 1:
                        if (!(_a.sent())) {
                            throw 'Not on TestRPC';
                        }
                        id = 'W3:' + W3_1.W3.getNextCounter();
                        return [2 /*return*/, this.w3
                                .sendRPC({
                                jsonrpc: '2.0',
                                method: 'evm_snapshot',
                                params: [],
                                id: id
                            })
                                .then(function (r) {
                                console.log('RPC RESPONSE: ', r);
                                return r.result;
                            })];
                }
            });
        });
    };
    /**
     * Revert the state of the blockchain to a previous snapshot.
     * Takes a single parameter, which is the snapshot id to revert to.
     * If no snapshot id is passed it will revert to the latest snapshot. Returns true.
     */
    TestRPC.prototype.revert = function (snapshotId) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.isTestRPC];
                    case 1:
                        if (!(_a.sent())) {
                            throw 'Not on TestRPC';
                        }
                        id = 'W3:' + W3_1.W3.getNextCounter();
                        return [2 /*return*/, this.w3
                                .sendRPC({
                                jsonrpc: '2.0',
                                method: 'evm_revert',
                                params: snapshotId ? [snapshotId] : [],
                                id: id
                            })
                                .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    return [2 /*return*/, true];
                                });
                            }); })];
                }
            });
        });
    };
    /**
     * Jump forward in time. Takes one parameter, which is the amount of time to increase in seconds.
     * Returns the total time adjustment, in seconds.
     */
    TestRPC.prototype.increaseTime = function (seconds) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.isTestRPC];
                    case 1:
                        if (!(_a.sent())) {
                            throw 'Not on TestRPC';
                        }
                        id = 'W3:' + W3_1.W3.getNextCounter();
                        return [2 /*return*/, this.w3
                                .sendRPC({
                                jsonrpc: '2.0',
                                method: 'evm_increaseTime',
                                params: [W3_1.W3.duration.seconds(seconds)],
                                id: id
                            })
                                .then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.mine()];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/, r.result];
                                    }
                                });
                            }); })];
                }
            });
        });
    };
    /**
     * Beware that due to the need of calling two separate testrpc methods and rpc calls overhead
     * it's hard to increase time precisely to a target point so design your test to tolerate
     * small fluctuations from time to time.
     *
     * @param target time in seconds
     */
    TestRPC.prototype.increaseTimeTo = function (target) {
        return __awaiter(this, void 0, void 0, function () {
            var now, diff;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.latestTime];
                    case 1:
                        now = _a.sent();
                        if (target < now) {
                            throw Error("Cannot increase current time(" + now + ") to a moment in the past(" + target + ")");
                        }
                        diff = target - now;
                        return [2 /*return*/, this.increaseTime(diff)];
                }
            });
        });
    };
    /**
     * Force a block to be mined. Takes no parameters. Mines a block independent of whether or not mining is started or stopped.
     */
    TestRPC.prototype.mine = function () {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.isTestRPC];
                    case 1:
                        if (!(_a.sent())) {
                            throw 'Not on TestRPC';
                        }
                        id = 'W3:' + W3_1.W3.getNextCounter();
                        return [2 /*return*/, this.w3
                                .sendRPC({
                                jsonrpc: '2.0',
                                method: 'evm_mine',
                                params: [],
                                id: id
                            })
                                .then(function (r) {
                                return;
                            })];
                }
            });
        });
    };
    TestRPC.prototype.advanceToBlock = function (blockNumber) {
        return __awaiter(this, void 0, void 0, function () {
            var lastBlock;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.w3.blockNumber];
                    case 1:
                        lastBlock = _a.sent();
                        if (lastBlock > blockNumber) {
                            throw Error("block number " + blockNumber + " is in the past (current is " + lastBlock + ")");
                        }
                        _a.label = 2;
                    case 2: return [4 /*yield*/, this.w3.blockNumber];
                    case 3:
                        if (!((_a.sent()) < blockNumber)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.mine()];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return TestRPC;
}());
exports.TestRPC = TestRPC;
//# sourceMappingURL=TestRPC.js.map