"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var bignumber_js_1 = require("bignumber.js"); // TODO change to BN
var Web3JS = require("web3");
// W3 is the only class wrapper over JS object, others are interfaces
// cannot just cast from JS, but ctor does some standard logic to resolve web3
// so we do not need cast but could just use new W3()
/** Convert number or hex string to BigNumber */
function toBN(value) {
    // TODO BN.js
    return new bignumber_js_1.BigNumber(value);
}
exports.toBN = toBN;
// tslint:disable:member-ordering
// tslint:disable:max-line-length
/**
 * Strongly-types wrapper over web3.js with additional helper methods.
 */
var W3 = /** @class */ (function () {
    function W3(provider, defaultAccount) {
        this._defaultTimeout = 240000;
        var tmpWeb3;
        if (typeof provider === 'undefined') {
            // tslint:disable-next-line:no-string-literal
            if ((typeof window !== 'undefined' &&
                typeof window['web3'] !== 'undefined' &&
                typeof window['web3'].currentProvider !== 'undefined') ||
                this._globalWeb3) {
                // tslint:disable-next-line:no-string-literal
                this._globalWeb3 = window['web3'];
                // tslint:disable-next-line:no-string-literal
                tmpWeb3 = new Web3JS(this._globalWeb3.currentProvider);
                console.log('Using an injected web3 provider.');
            }
            else {
                // set the provider you want from Web3.providers
                if (typeof window === 'undefined' || window.location.protocol !== 'https:') {
                    tmpWeb3 = new Web3JS(new Web3JS.providers.HttpProvider('http://localhost:8545'));
                    console.log('Cannot find an injected web3 provider. Using HttpProvider(http://localhost:8545).');
                }
                else {
                    // tslint:disable-next-line:max-line-length
                    console.log('Cannot find an injected web3 provider. Running on https, will not try to access localhost at 8545');
                }
            }
        }
        else {
            // regardless if a web3 exists, we create a new one for a specific provider
            tmpWeb3 = new Web3JS(provider);
            console.log('Using a provider from constructor.');
        }
        if (!tmpWeb3.version.api.startsWith('0.20')) {
            throw 'Only web3 0.20.xx package is currently supported';
        }
        this.web3 = tmpWeb3;
        // set and override eth's default account with a given value or use eth's one if it is set
        if (defaultAccount) {
            // set property, that will also set this.web3.defaultAccount
            this.defaultAccount = defaultAccount;
        }
        else if (this.web3.defaultAccount) {
            // set private field directly
            this._defaultAccount = this.web3.defaultAccount;
        }
        this.updateNetworkInfo();
    }
    Object.defineProperty(W3, "default", {
        /**
         * Default W3 instance that is used as a fallback when such an instance is not provided to a constructor.
         * You must set it explicitly via W3.default setter. Use an empty `new W3()` constructor to get an instance that
         * automatically resolves to a global web3 instance `window['web3']` provided by e.g. MIST/Metamask or connects
         * to the default 8545 port if no global instance is present.
         */
        get: function () {
            if (W3._default) {
                return W3._default;
            }
            throw 'Default W3 instance is not set. Use W3.default setter.';
        },
        /**
         * Set default W3 instance.
         */
        set: function (w3) {
            W3._default = w3;
        },
        enumerable: true,
        configurable: true
    });
    /** Get Global W3 incrementing counter. Starts with zero.  */
    W3.getNextCounter = function () {
        // node is single-threaded
        // same provider in two W3 instances is OK, counter will be unique accross them
        var value = W3._counter;
        W3._counter++;
        return value;
    };
    Object.defineProperty(W3.prototype, "currentProvider", {
        /** Current Web3 provider. */
        get: function () {
            return this.web3 ? this.web3.currentProvider : undefined;
        },
        enumerable: true,
        configurable: true
    });
    /** Convert number or hex string to BigNumber */
    W3.prototype.toBigNumber = function (value) {
        return this.web3.toBigNumber(value);
    };
    /** Converts a number or number string to its HEX representation. */
    W3.prototype.fromDecimal = function (value) {
        return this.web3.fromDecimal(value);
    };
    Object.defineProperty(W3.prototype, "defaultAccount", {
        /** Default account for sending transactions without explicit txParams. */
        get: function () {
            return this._defaultAccount;
        },
        set: function (defaultAccount) {
            this._defaultAccount = defaultAccount;
            this.web3.defaultAccount = defaultAccount;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "defaultTimeout", {
        /** Default timeout in seconds. */
        get: function () {
            return this._defaultTimeout / 1000;
        },
        set: function (defaultTimeout) {
            if (defaultTimeout && defaultTimeout > 240) {
                this._defaultTimeout = defaultTimeout;
            }
            else {
                throw new Error('Bad defaultTimeout value.');
            }
        },
        enumerable: true,
        configurable: true
    });
    /** Request netid string from ctor or after provider change */
    W3.prototype.updateNetworkInfo = function (netid) {
        var _this = this;
        if (!netid) {
            this.networkId.then(function (nid) { return (_this._netId = nid); });
        }
        else {
            this._netId = netid;
        }
        this._netNode = new Promise(function (resolve, reject) {
            return _this.web3.version.getNode(function (error, result) { return (error ? reject(error) : resolve(result)); });
        });
    };
    Object.defineProperty(W3.prototype, "accounts", {
        /*
          Below are frequently used functions that should not depend on web3 API (0.20 or 1.0).
          Will update them for web3 1.0 when truffle-contract support it without sendAsync error.
          */
        /** Returns a list of accounts the node controlst */
        get: function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                return _this.web3.eth.getAccounts(function (error, result) { return (error ? reject(error) : resolve(result)); });
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "web3API", {
        /** Web3.js version API */
        get: function () {
            return this.web3.version.api;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "isPre1API", {
        /** True if current web3.js version is 0.20.x. */
        get: function () {
            return this.web3API.startsWith('0.20.');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "isTestRPC", {
        /** True if current node name contains TestRPC string */
        get: function () {
            return this._netNode.then(function (node) {
                return node.includes('TestRPC');
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "networkId", {
        /** Get network ID. */
        get: function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                return _this.web3.version.getNetwork(function (error, result) {
                    if (error) {
                        return reject(error);
                    }
                    if (result + '' !== _this._netId) {
                        _this.updateNetworkInfo(result + '');
                    }
                    return resolve(result);
                });
            });
        },
        enumerable: true,
        configurable: true
    });
    /** Set web3 provider and update network info asynchronously. */
    W3.prototype.setProvider = function (provider) {
        this.web3.setProvider(provider);
        this.updateNetworkInfo();
    };
    /** Send raw JSON RPC request to the current provider. */
    W3.prototype.sendRPC = function (payload) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.isPre1API) {
                _this.web3.currentProvider.sendAsync(payload, function (e, r) {
                    if (e) {
                        reject(e);
                    }
                    else {
                        resolve(r);
                    }
                });
            }
            else {
                _this.web3.currentProvider.send(payload, function (e, r) {
                    if (e) {
                        reject(e);
                    }
                    else {
                        resolve(r);
                    }
                });
            }
        });
    };
    Object.defineProperty(W3.prototype, "latestTime", {
        /** Returns the time of the last mined block in seconds. */
        get: function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                if (_this.isPre1API) {
                    _this.web3.eth.getBlock('latest', function (err, res) {
                        if (err) {
                            reject(err);
                        }
                        else {
                            resolve(res.timestamp);
                        }
                    });
                }
                else {
                    reject('web3 1.0 support is not implemented');
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(W3.prototype, "blockNumber", {
        /** Returns the current block number */
        get: function () {
            var _this = this;
            // getBlockNumber(callback: (err: Error, blockNumber: number) => void): void;
            return new Promise(function (resolve, reject) {
                if (_this.isPre1API) {
                    _this.web3.eth.getBlockNumber(function (err, res) {
                        if (err) {
                            reject(err);
                        }
                        else {
                            resolve(res);
                        }
                    });
                }
                else {
                    reject('web3 1.0 support is not implemented');
                }
            });
        },
        enumerable: true,
        configurable: true
    });
    /** Async unlock while web3.js only has sync version. This function uses `personal_unlockAccount` RPC message that is not available in some web3 providers. */
    W3.prototype.unlockAccount = function (address, password, duration) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            var _this = this;
            return __generator(this, function (_a) {
                id = 'W3:' + W3.getNextCounter();
                return [2 /*return*/, this.sendRPC({
                        jsonrpc: '2.0',
                        method: 'personal_unlockAccount',
                        params: [address, password, duration || 10],
                        id: id
                    }).then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (r.error) {
                                return [2 /*return*/, false];
                            }
                            return [2 /*return*/, r.result];
                        });
                    }); })];
            });
        });
    };
    /** Get account balance */
    W3.prototype.getBalance = function (address) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.web3.eth.getBalance(address, function (error, result) {
                            if (error) {
                                reject(error);
                            }
                            else {
                                resolve(result);
                            }
                        });
                    })];
            });
        });
    };
    /** Sign using eth.sign but with prefix as personal_sign */
    W3.prototype.ethSignRaw = function (hex, account) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                // NOTE geth already adds the prefix to eth.sign, no need to do so manually
                // hex = hex.replace('0x', '');
                // let prefix = '\x19Ethereum Signed Message:\n' + (hex.length / 2);
                // let message = this.web3.toHex(prefix) + hex;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.web3.eth.sign(account, hex, function (err, res) {
                            if (err) {
                                reject(err);
                            }
                            resolve(res);
                        });
                    })];
            });
        });
    };
    /** Sign a message */
    W3.prototype.sign = function (message, account, password) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                message = W3.toHex(message);
                return [2 /*return*/, this.signRaw(message, account, password)];
            });
        });
    };
    /** Message already as hex */
    W3.prototype.signRaw = function (message, account, password) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            var _this = this;
            return __generator(this, function (_a) {
                id = 'W3:' + W3.getNextCounter();
                console.log('signRaw MESSAGE', message);
                return [2 /*return*/, this.sendRPC({
                        jsonrpc: '2.0',
                        method: 'personal_sign',
                        params: password ? [message, account, password] : [message, account],
                        id: id
                    }).then(function (r) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            if (r.error) {
                                console.log('ERROR:', r.error);
                                throw new Error(r.error.message);
                            }
                            return [2 /*return*/, r.result];
                        });
                    }); })];
            });
        });
    };
    Object.defineProperty(W3.prototype, "isMetaMask", {
        /** True if current web3 provider is from MetaMask. */
        get: function () {
            try {
                return this.web3.currentProvider.isMetaMask ? true : false;
            }
            catch (_a) {
                return false;
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Get the numbers of transactions sent from this address.
     * @param account The address to get the numbers of transactions from.
     * @param defaultBlock (optional) If you pass this parameter it will not use the default block set with.
     */
    W3.prototype.getTransactionCount = function (account, defaultBlock) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                account = account || this.defaultAccount;
                if (!account) {
                    throw new Error('No default account set to call getTransactionCount without a given account address');
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.web3.eth.getTransactionCount(account, defaultBlock, function (e, r) {
                            if (e) {
                                reject(e);
                            }
                            else {
                                resolve(r);
                            }
                        });
                    })];
            });
        });
    };
    /**
     * Sends a raw signed transaction and returns tx hash. Use waitTransactionReceipt method on w3 or a contract to get a tx receipt.
     * @param to Target contract address or zero address (W3.zeroAddress) to deploy a new contract.
     * @param privateKey Private key hex string prefixed with 0x.
     * @param data Payload data.
     * @param txParams Tx parameters.
     * @param nonce Nonce override if needed to replace a pending transaction.
     */
    W3.prototype.sendSignedTransaction = function (to, privateKey, data, txParams, nonce) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, EthereumTx, pb, nid, _b, signedTxParams, tx, serializedTx, raw;
            var _this = this;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.isPre1API) {
                            throw new Error('Web3.js v.1.0 is not supported yet');
                        }
                        if (!to || !W3.isValidAddress(to)) {
                            throw new Error('To address is not set in sendSignedTransaction');
                        }
                        if (!privateKey) {
                            throw new Error('PrivateKey is not set in sendSignedTransaction');
                        }
                        txParams = txParams || W3.TX.txParamsDefaultSend(this.defaultAccount);
                        _a = nonce;
                        if (_a) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getTransactionCount(txParams.from)];
                    case 1:
                        _a = (_c.sent());
                        _c.label = 2;
                    case 2:
                        nonce = _a;
                        EthereumTx = W3.TX.getEthereumjsTx();
                        pb = W3.EthUtils.toBuffer(privateKey);
                        _b = this._netId;
                        if (_b) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.networkId];
                    case 3:
                        _b = (_c.sent());
                        _c.label = 4;
                    case 4:
                        nid = +(_b);
                        signedTxParams = {
                            nonce: W3.toHex(nonce),
                            gasPrice: W3.toHex(txParams.gasPrice),
                            gasLimit: W3.toHex(txParams.gas),
                            to: to,
                            value: W3.toHex(txParams.value),
                            data: data,
                            chainId: nid
                        };
                        if (W3.zeroAddress === to) {
                            delete signedTxParams.to;
                        }
                        tx = new EthereumTx(signedTxParams);
                        tx.sign(pb);
                        serializedTx = tx.serialize();
                        raw = "0x" + serializedTx.toString('hex');
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                _this.web3.eth.sendRawTransaction(raw, function (e, r) {
                                    if (e) {
                                        reject(e);
                                    }
                                    else {
                                        resolve(r);
                                    }
                                });
                            })];
                }
            });
        });
    };
    /**
     * Returns the receipt of a transaction by transaction hash. Retries for up to 240 seconds.
     * @param hashString The transaction hash.
     * @param timeoutSeconds Timeout in seconds, must be above 240 or ignored.
     */
    W3.prototype.waitTransactionReceipt = function (hashString, timeoutSeconds) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (accept, reject) {
                        var timeout = timeoutSeconds && timeoutSeconds > 240 ? timeoutSeconds * 1000 : _this._defaultTimeout;
                        var start = new Date().getTime();
                        var makeAttempt = function () {
                            _this.web3.eth.getTransactionReceipt(hashString, function (err, receipt) {
                                if (err) {
                                    return reject(err);
                                }
                                if (receipt != null) {
                                    return accept(receipt);
                                }
                                if (timeout > 0 && new Date().getTime() - start > timeout) {
                                    return reject(new Error('Transaction ' + hashString + " wasn't processed in " + timeout / 1000 + ' seconds!'));
                                }
                                setTimeout(makeAttempt, 1000);
                            });
                        };
                        makeAttempt();
                    })];
            });
        });
    };
    W3._counter = 0;
    /** Web3 providers. */
    W3.providers = Web3JS.providers;
    return W3;
}());
exports.W3 = W3;
(function (W3) {
    /** Hex zero address. */
    W3.zeroAddress = '0x0000000000000000000000000000000000000000';
    /** Check if Ethereum address is in valid format. */
    function isValidAddress(addr) {
        return W3.EthUtils.isValidAddress(addr);
    }
    W3.isValidAddress = isValidAddress;
    /** Utf8 package. */
    W3.Utf8 = require('utf8');
    /**
     * Convert value to hex with optional left padding. If a string is already a hex it will be converted to lower case.
     * @param value Value to convert to hex
     * @param size Size of number in bits (8 for int8, 16 for uint16, etc)
     */
    function toHex(value, stripPrefix, size) {
        var HEX_CHAR_SIZE = 4;
        if (typeof value === 'string') {
            if (size) {
                throw new Error('W3.toHex: using optional size argument with strings is not supported');
            }
            if (!value.startsWith('0x')) {
                // non-hex string
                return W3.utf8ToHex(value, stripPrefix);
            }
            else {
                var lowerCase = value.toLowerCase();
                return stripPrefix ? lowerCase.slice(2) : lowerCase;
            }
        }
        var hexWithPrefix;
        if (value.isBigNumber) {
            var bn = value;
            var hex = bn.toString(16);
            hexWithPrefix = bn.lessThan(0) ? '-0x' + hex.substr(1) : '0x' + hex;
        }
        else {
            hexWithPrefix = W3.EthUtils.bufferToHex(W3.EthUtils.toBuffer(value));
        }
        // numbers, big numbers, and hex strings
        if (size) {
            // tslint:disable-next-line:no-bitwise
            var hexNoPrefix = hexWithPrefix.slice(2);
            // tslint:disable-next-line:no-bitwise
            var leftPadded = W3.leftPad(hexNoPrefix, size / HEX_CHAR_SIZE, value < 0 ? 'F' : '0');
            return stripPrefix ? leftPadded : '0x' + leftPadded;
        }
        else {
            // tslint:disable-next-line:no-bitwise
            return stripPrefix ? hexWithPrefix.slice(2) : hexWithPrefix;
        }
    }
    W3.toHex = toHex;
    /** String left pad. Same as the notorious left-pad package as a single function. */
    function leftPad(str, len, ch) {
        // the notorious 12-lines npm package
        str = String(str);
        var i = -1;
        if (!ch && ch !== 0) {
            ch = ' ';
        }
        len = len - str.length;
        while (++i < len) {
            str = ch + str;
        }
        return str;
    }
    W3.leftPad = leftPad;
    /** Utf8 to hex convertor. */
    function utf8ToHex(str, stripPrefix) {
        // this is from web3 1.0
        str = W3.Utf8.encode(str);
        var hex = '';
        // remove \u0000 padding from either side
        str = str.replace(/^(?:\u0000)*/, '');
        str = str
            .split('')
            .reverse()
            .join('');
        str = str.replace(/^(?:\u0000)*/, '');
        str = str
            .split('')
            .reverse()
            .join('');
        for (var i = 0; i < str.length; i++) {
            var code = str.charCodeAt(i);
            // if (code !== 0) {
            var n = code.toString(16);
            hex += n.length < 2 ? '0' + n : n;
            // }
        }
        return stripPrefix ? hex : '0x' + hex;
    }
    W3.utf8ToHex = utf8ToHex;
    /** Ethereumjs-util package. */
    W3.EthUtils = require('ethereumjs-util');
    /** Creates SHA-3 hash of the input. */
    function sha3(a, bits) {
        return W3.EthUtils.bufferToHex(W3.EthUtils.sha3(a, bits));
    }
    W3.sha3 = sha3;
    /** Creates SHA256 hash of the input. */
    function sha256(a) {
        return W3.EthUtils.bufferToHex(W3.EthUtils.sha256(a));
    }
    W3.sha256 = sha256;
    /** ECDSA sign. */
    function sign(message, privateKey) {
        var mb = W3.EthUtils.toBuffer(message);
        var pb = W3.EthUtils.toBuffer(privateKey);
        var personalHash = W3.EthUtils.hashPersonalMessage(mb);
        var signature = W3.EthUtils.ecsign(personalHash, pb);
        var rpcSignature = W3.EthUtils.toRpcSig(signature.v, signature.r, signature.s);
        return rpcSignature;
    }
    W3.sign = sign;
    /** ECDSA public key recovery from signature. */
    function ecrecover(message, signature) {
        var mb = W3.EthUtils.toBuffer(message);
        var sigObject = W3.EthUtils.fromRpcSig(signature);
        var personalHash = W3.EthUtils.hashPersonalMessage(mb);
        var recoveredPubKeyBuffer = W3.EthUtils.ecrecover(personalHash, sigObject.v, sigObject.r, sigObject.s);
        var recoveredAddress = W3.EthUtils.pubToAddress(recoveredPubKeyBuffer);
        var addr = W3.EthUtils.bufferToHex(recoveredAddress);
        return addr;
    }
    W3.ecrecover = ecrecover;
    var _keythereum;
    /**
     * Get Keythereum instance. https://github.com/ethereumjs/keythereum
     */
    function getKeythereum() {
        if (_keythereum) {
            return _keythereum;
        }
        // tslint:disable-next-line:no-string-literal
        if (typeof window !== 'undefined' && typeof window['keythereum'] !== 'undefined') {
            // tslint:disable-next-line:no-string-literal
            _keythereum = window['keythereum'];
        }
        else {
            _keythereum = require('keythereum');
        }
        return _keythereum;
    }
    W3.getKeythereum = getKeythereum;
    /** Truffle Contract */
    var TX;
    (function (TX) {
        /** 4500000 gas @ 2 Gwei */
        function txParamsDefaultDeploy(from, gas, gasPrice) {
            if (gasPrice && gasPrice > 40000000000) {
                throw new Error("Given gasPrice " + gasPrice + " is above 40Gwei (our default is 2 Gwei, common value for fast transactions is 20Gwei), this could be costly. Construct txParams manually if you know what you are doing.");
            }
            if (gas && gas > 4500000) {
                throw new Error("Given gas " + gas + " is too large and could exceed block size.");
            }
            return {
                from: from,
                gas: gas || 4500000,
                gasPrice: gasPrice || 2000000000,
                value: 0
            };
        }
        TX.txParamsDefaultDeploy = txParamsDefaultDeploy;
        /** 50000 gas @ 2 Gwei */
        function txParamsDefaultSend(from, gas, gasPrice) {
            if (gasPrice && gasPrice > 40000000000) {
                throw new Error("Given gasPrice " + gasPrice + " is above 40Gwei (our default is 2 Gwei, common value for fast transactions is 20Gwei), this could be costly. Construct txParams manually if you know what you are doing.");
            }
            if (gas && gas > 500000) {
                throw new Error("Given gas " + gas + " is too large for a normal transaction (>500k). Use txParamsDefaultDeploy or construct params manually.");
            }
            return {
                from: from,
                gas: gas || 50000,
                gasPrice: gasPrice || 2000000000,
                value: 0
            };
        }
        TX.txParamsDefaultSend = txParamsDefaultSend;
        var _ethereumjsTx;
        function getEthereumjsTx() {
            if (_ethereumjsTx) {
                return _ethereumjsTx;
            }
            // tslint:disable-next-line:no-string-literal
            if (typeof window !== 'undefined' && typeof window['ethereumjs-tx'] !== 'undefined') {
                // tslint:disable-next-line:no-string-literal
                _ethereumjsTx = window['ethereumjs-tx'];
            }
            else {
                _ethereumjsTx = require('ethereumjs-tx');
            }
            return _ethereumjsTx;
        }
        TX.getEthereumjsTx = getEthereumjsTx;
    })(TX = W3.TX || (W3.TX = {}));
    W3.duration = {
        seconds: function (val) {
            return val;
        },
        minutes: function (val) {
            return val * this.seconds(60);
        },
        hours: function (val) {
            return val * this.minutes(60);
        },
        days: function (val) {
            return val * this.hours(24);
        },
        weeks: function (val) {
            return val * this.days(7);
        },
        years: function (val) {
            return val * this.days(365);
        }
    };
})(W3 = exports.W3 || (exports.W3 = {}));
exports.W3 = W3;
//# sourceMappingURL=W3.js.map