import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from '..';
/**
 * BotManageable API
 */
export declare class BotManageable extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {
        _wallet: string;
    }, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<BotManageable>;
    static at(address: string | object, w3?: W3): Promise<BotManageable>;
    static deployed(w3?: W3): Promise<BotManageable>;
    static newData(ctorParams?: {
        _wallet: string;
    }, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {
        _wallet: string;
    }, w3?: W3, link?: SoltsiceContract[]);
    isOwner(_address: string, txParams?: W3.TX.TxParams): Promise<boolean>;
    unpause: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    wallet(txParams?: W3.TX.TxParams): Promise<string>;
    paused(txParams?: W3.TX.TxParams): Promise<boolean>;
    pause: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    enableBot: ((_botAddress: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((_botAddress: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (_botAddress: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (_botAddress: string) => Promise<string>;
    } & {
        estimateGas: (_botAddress: string) => Promise<number>;
    };
    disableBot: ((_botAddress: string, _fromTimeStampSeconds: number | BigNumber, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((_botAddress: string, _fromTimeStampSeconds: number | BigNumber, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (_botAddress: string, _fromTimeStampSeconds: number | BigNumber, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (_botAddress: string, _fromTimeStampSeconds: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (_botAddress: string, _fromTimeStampSeconds: number | BigNumber) => Promise<number>;
    };
    isBot(_botAddress: string, txParams?: W3.TX.TxParams): Promise<boolean>;
    isBotAt(_botAddress: string, _atTimeStampSeconds: BigNumber | number, txParams?: W3.TX.TxParams): Promise<boolean>;
}
