import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from '..';
/**
 * DummyContract API
 */
export declare class DummyContract extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {
        _secret: BigNumber | number;
        _wellKnown: BigNumber | number;
        _array: BigNumber[] | number[];
    }, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<DummyContract>;
    static at(address: string | object, w3?: W3): Promise<DummyContract>;
    static deployed(w3?: W3): Promise<DummyContract>;
    static newData(ctorParams?: {
        _secret: BigNumber | number;
        _wellKnown: BigNumber | number;
        _array: BigNumber[] | number[];
    }, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {
        _secret: BigNumber | number;
        _wellKnown: BigNumber | number;
        _array: BigNumber[] | number[];
    }, w3?: W3, link?: SoltsiceContract[]);
    array(_0: BigNumber | number, txParams?: W3.TX.TxParams): Promise<BigNumber>;
    renounceOwnership: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    owner(txParams?: W3.TX.TxParams): Promise<string>;
    isOwner(txParams?: W3.TX.TxParams): Promise<boolean>;
    wellKnown(txParams?: W3.TX.TxParams): Promise<BigNumber>;
    transferOwnership: ((newOwner: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((newOwner: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (newOwner: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
    getPrivate(txParams?: W3.TX.TxParams): Promise<BigNumber>;
    setPrivate: ((_newValue: number | BigNumber, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((_newValue: number | BigNumber, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (_newValue: number | BigNumber, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (_newValue: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (_newValue: number | BigNumber) => Promise<number>;
    };
    getPublic(txParams?: W3.TX.TxParams): Promise<BigNumber>;
    setPublic: ((_newValue: number | BigNumber, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((_newValue: number | BigNumber, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (_newValue: number | BigNumber, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (_newValue: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (_newValue: number | BigNumber) => Promise<number>;
    };
    ArrayTypesTest: ((_array: number[] | BigNumber[], txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((_array: number[] | BigNumber[], txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (_array: number[] | BigNumber[], privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (_array: number[] | BigNumber[]) => Promise<string>;
    } & {
        estimateGas: (_array: number[] | BigNumber[]) => Promise<number>;
    };
    funcArrayInArguments(_array: string[], txParams?: W3.TX.TxParams): Promise<string[]>;
}
