import { W3, SoltsiceContract } from '..';
/**
 * MultiOwnable API
 */
export declare class MultiOwnable extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {
        _wallet: string;
    }, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<MultiOwnable>;
    static at(address: string | object, w3?: W3): Promise<MultiOwnable>;
    static deployed(w3?: W3): Promise<MultiOwnable>;
    static newData(ctorParams?: {
        _wallet: string;
    }, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {
        _wallet: string;
    }, w3?: W3, link?: SoltsiceContract[]);
    wallet(txParams?: W3.TX.TxParams): Promise<string>;
    paused(txParams?: W3.TX.TxParams): Promise<boolean>;
    isOwner(_address: string, txParams?: W3.TX.TxParams): Promise<boolean>;
    pause: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    unpause: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
}
