import { W3, SoltsiceContract } from '..';
/**
 * Ownable API
 */
export declare class Ownable extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<Ownable>;
    static at(address: string | object, w3?: W3): Promise<Ownable>;
    static deployed(w3?: W3): Promise<Ownable>;
    static newData(ctorParams?: {}, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    owner(txParams?: W3.TX.TxParams): Promise<string>;
    isOwner(txParams?: W3.TX.TxParams): Promise<boolean>;
    renounceOwnership: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    transferOwnership: ((newOwner: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((newOwner: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (newOwner: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
}
