import { BigNumber } from 'bignumber.js';
import { W3, SoltsiceContract } from '..';
/**
 * Storage API
 */
export declare class Storage extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<Storage>;
    static at(address: string | object, w3?: W3): Promise<Storage>;
    static deployed(w3?: W3): Promise<Storage>;
    static newData(ctorParams?: {}, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    renounceOwnership: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
    owner(txParams?: W3.TX.TxParams): Promise<string>;
    isOwner(txParams?: W3.TX.TxParams): Promise<boolean>;
    transferOwnership: ((newOwner: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((newOwner: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (newOwner: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (newOwner: string) => Promise<string>;
    } & {
        estimateGas: (newOwner: string) => Promise<number>;
    };
    getUIntValue(record: string, txParams?: W3.TX.TxParams): Promise<BigNumber>;
    setUIntValue: ((record: string, value: number | BigNumber, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: number | BigNumber, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: number | BigNumber, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (record: string, value: number | BigNumber) => Promise<number>;
    };
    getStringValue(record: string, txParams?: W3.TX.TxParams): Promise<string>;
    setStringValue: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: string) => Promise<string>;
    } & {
        estimateGas: (record: string, value: string) => Promise<number>;
    };
    getAddressValue(record: string, txParams?: W3.TX.TxParams): Promise<string>;
    setAddressValue: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: string) => Promise<string>;
    } & {
        estimateGas: (record: string, value: string) => Promise<number>;
    };
    getBytesValue(record: string, txParams?: W3.TX.TxParams): Promise<string>;
    setBytesValue: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: string, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: string, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: string) => Promise<string>;
    } & {
        estimateGas: (record: string, value: string) => Promise<number>;
    };
    getBooleanValue(record: string, txParams?: W3.TX.TxParams): Promise<boolean>;
    setBooleanValue: ((record: string, value: boolean, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: boolean, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: boolean, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: boolean) => Promise<string>;
    } & {
        estimateGas: (record: string, value: boolean) => Promise<number>;
    };
    getIntValue(record: string, txParams?: W3.TX.TxParams): Promise<BigNumber>;
    setIntValue: ((record: string, value: number | BigNumber, txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((record: string, value: number | BigNumber, txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (record: string, value: number | BigNumber, privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: (record: string, value: number | BigNumber) => Promise<string>;
    } & {
        estimateGas: (record: string, value: number | BigNumber) => Promise<number>;
    };
}
