import { W3, SoltsiceContract } from '..';
/**
 * StorageFactory API
 */
export declare class StorageFactory extends SoltsiceContract {
    static readonly artifacts: any;
    static readonly bytecodeHash: string | undefined;
    static new(deploymentParams: W3.TX.TxParams, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[], privateKey?: string): Promise<StorageFactory>;
    static at(address: string | object, w3?: W3): Promise<StorageFactory>;
    static deployed(w3?: W3): Promise<StorageFactory>;
    static newData(ctorParams?: {}, w3?: W3): string;
    protected constructor(deploymentParams: string | W3.TX.TxParams | object, ctorParams?: {}, w3?: W3, link?: SoltsiceContract[]);
    existingStorage(_0: string, txParams?: W3.TX.TxParams): Promise<string>;
    produce: ((txParams?: W3.TX.TxParams | undefined, privateKey?: string | undefined) => Promise<W3.TX.TransactionResult>) & {
        sendTransaction: ((txParams?: W3.TX.TxParams | undefined) => Promise<string>) & {
            sendSigned: (privateKey: string, txParams?: W3.TX.TxParams | undefined, nonce?: number | undefined) => Promise<string>;
        };
    } & {
        data: () => Promise<string>;
    } & {
        estimateGas: () => Promise<number>;
    };
}
