"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JsonRPCRequest = /** @class */ (function () {
    function JsonRPCRequest(method, params, notification) {
        this.jsonrpc = '2.0';
        this.method = method;
        this.params = params;
        if (!notification) {
            this.id = JsonRPCRequest.nextCounter();
        }
    }
    JsonRPCRequest.nextCounter = function () {
        JsonRPCRequest.counter++;
        return JsonRPCRequest.counter;
    };
    JsonRPCRequest.counter = 0;
    return JsonRPCRequest;
}());
exports.JsonRPCRequest = JsonRPCRequest;
var JsonRPCResponse = /** @class */ (function () {
    function JsonRPCResponse(id, result, error) {
        this.jsonrpc = '2.0';
        this.id = id;
        this.result = result;
        this.error = error;
    }
    return JsonRPCResponse;
}());
exports.JsonRPCResponse = JsonRPCResponse;
var JsonRPCError = /** @class */ (function () {
    function JsonRPCError(code, message, data) {
        this.code = code;
        this.message = message;
        this.data = data;
    }
    return JsonRPCError;
}());
exports.JsonRPCError = JsonRPCError;
//# sourceMappingURL=jsonrpc.js.map