import { W3 } from './W3';
import { Storage } from './contracts';
/**
 * Get storage contract on active network for account.
 * @param w3 W3 instance.
 * @param accountAddress Storage owner address.
 * @param createOnMainNet If on Mainnet this parameter must be true to create a new storage contract (will cost deployment gas).
 * @param privateKey When provided, transactions will be signed and sent via sendRawTransaction.
 */
export declare function getStorage(w3: W3, accountAddress: string, createOnMainNet?: boolean, privateKey?: string): Promise<Storage>;
