"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var W3_1 = require("./W3");
var contracts_1 = require("./contracts");
var constants_1 = require("./constants");
/**
 * Get storage contract on active network for account.
 * @param w3 W3 instance.
 * @param accountAddress Storage owner address.
 * @param createOnMainNet If on Mainnet this parameter must be true to create a new storage contract (will cost deployment gas).
 * @param privateKey When provided, transactions will be signed and sent via sendRawTransaction.
 */
function getStorage(w3, accountAddress, createOnMainNet, privateKey) {
    return __awaiter(this, void 0, void 0, function () {
        var cached, nid, txDeploy, storageFactory, storageAddress, s;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cached = w3[accountAddress];
                    if (cached) {
                        return [2 /*return*/, cached];
                    }
                    return [4 /*yield*/, w3.networkId];
                case 1:
                    nid = _a.sent();
                    txDeploy = W3_1.W3.TX.txParamsDefaultDeploy(accountAddress, 900000, 1000000000);
                    return [4 /*yield*/, w3.isTestRPC];
                case 2:
                    if (!_a.sent()) return [3 /*break*/, 4];
                    return [4 /*yield*/, contracts_1.StorageFactory.new(txDeploy, undefined, w3, undefined, privateKey)];
                case 3:
                    storageFactory = _a.sent();
                    return [3 /*break*/, 11];
                case 4:
                    if (!(nid === '3')) return [3 /*break*/, 6];
                    return [4 /*yield*/, contracts_1.StorageFactory.at(constants_1.ropstenStorageFactory, w3)];
                case 5:
                    storageFactory = _a.sent();
                    return [3 /*break*/, 11];
                case 6:
                    if (!(nid === '4')) return [3 /*break*/, 8];
                    return [4 /*yield*/, contracts_1.StorageFactory.at(constants_1.rinkebyStorageFactory, w3)];
                case 7:
                    storageFactory = _a.sent();
                    return [3 /*break*/, 11];
                case 8:
                    if (!(nid === '1')) return [3 /*break*/, 10];
                    return [4 /*yield*/, contracts_1.StorageFactory.at(constants_1.mainnetStorageFactory, w3)];
                case 9:
                    storageFactory = _a.sent();
                    return [3 /*break*/, 11];
                case 10: throw new Error("Storage on network id " + nid + " is not supported.");
                case 11: return [4 /*yield*/, storageFactory.existingStorage(accountAddress)];
                case 12:
                    storageAddress = _a.sent();
                    if (!(storageAddress === W3_1.W3.zeroAddress)) return [3 /*break*/, 15];
                    // create a new one
                    if (nid === '1' && !createOnMainNet) {
                        throw new Error("Please explicitly provide constructor parameter createOnMainNet = true to create a new storage on mainnet.");
                    }
                    return [4 /*yield*/, storageFactory.produce(txDeploy)];
                case 13:
                    _a.sent();
                    return [4 /*yield*/, storageFactory.existingStorage(accountAddress)];
                case 14:
                    storageAddress = _a.sent();
                    if (storageAddress === W3_1.W3.zeroAddress) {
                        throw new Error("Cannot create new storage for " + accountAddress);
                    }
                    _a.label = 15;
                case 15: return [4 /*yield*/, contracts_1.Storage.at(storageAddress, w3)];
                case 16:
                    s = _a.sent();
                    w3[accountAddress] = s;
                    return [2 /*return*/, s];
            }
        });
    });
}
exports.getStorage = getStorage;
//# sourceMappingURL=storage.js.map