"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("../");
var contracts_1 = require("../contracts");
var bignumber_js_1 = require("bignumber.js");
var ganache = require("ganache-cli");
var privateKey = '0x3c66198bb60b1d2c95b4e37d4a9d414234c0d9a44d1f394617b48d25c6fceccd';
var w3 = new __1.W3(ganache.provider({
    network_id: 314,
    accounts: [
        { balance: '0xD3C21BCECCEDA1000000', secretKey: privateKey }
    ]
}));
w3.defaultAccount = __1.testAddresses[0];
__1.W3.default = w3;
var dummyAddress;
describe('W3 tests', function () {
    it('Could convert to hex', function () {
        return __awaiter(this, void 0, void 0, function () {
            var hex, hexString, hexBN, hexNumber, hexGasPrice, recoveredGasPrice;
            return __generator(this, function (_a) {
                hex = __1.W3.toHex('0xABC123');
                expect(hex).toEqual('0xABC123'.toLowerCase());
                console.log('0xABC123 hex', hex, true);
                hexString = __1.W3.toHex('Soltsice', false);
                console.log('Soltsice hex', hexString);
                hexBN = __1.W3.toHex(new bignumber_js_1.BigNumber(1234567), true, 64);
                console.log('BigNumber(1234567) hex', hexBN);
                hexNumber = __1.W3.toHex(1234567, true);
                console.log('1234567 hex', hexNumber);
                hexGasPrice = __1.W3.toHex(20000000000);
                console.log('20 Gwei hex', hexGasPrice);
                recoveredGasPrice = new bignumber_js_1.BigNumber(hexGasPrice);
                expect(recoveredGasPrice).toEqual(new bignumber_js_1.BigNumber(20000000000));
                return [2 /*return*/];
            });
        });
    });
    it('Should return tx number', function () {
        return __awaiter(this, void 0, void 0, function () {
            var nonce, dummy, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, w3.getTransactionCount()];
                    case 1:
                        nonce = _a.sent();
                        expect(nonce).toBe(0);
                        return [4 /*yield*/, contracts_1.DummyContract.new(__1.W3.TX.txParamsDefaultDeploy(__1.testAddresses[0]), { _secret: __1.toBN(123), _wellKnown: __1.toBN(456), _array: [1, 2, 3] })];
                    case 2:
                        dummy = _a.sent();
                        dummyAddress = dummy.address;
                        return [4 /*yield*/, w3.getTransactionCount()];
                    case 3:
                        nonce = _a.sent();
                        expect(nonce).toBe(1);
                        return [4 /*yield*/, dummy.setPublic(123)];
                    case 4:
                        tx = _a.sent();
                        console.log('TX:', tx);
                        return [4 /*yield*/, w3.getTransactionCount()];
                    case 5:
                        nonce = _a.sent();
                        expect(nonce).toBe(2);
                        return [2 /*return*/];
                }
            });
        });
    });
    it('Could send signed tx', function () {
        return __awaiter(this, void 0, void 0, function () {
            var newPublic, nonce, dummy, txParams, txHash, _a, _b, _c, tx1, tx2, newPublic1, newPublic2, tx3, newPublic3, nonce2;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        newPublic = 456789;
                        return [4 /*yield*/, w3.getTransactionCount()];
                    case 1:
                        nonce = _d.sent();
                        return [4 /*yield*/, contracts_1.DummyContract.at(dummyAddress)];
                    case 2:
                        dummy = _d.sent();
                        txParams = __1.W3.TX.txParamsDefaultSend(w3.defaultAccount);
                        _b = (_a = w3).sendSignedTransaction;
                        _c = [dummy.address, privateKey];
                        return [4 /*yield*/, dummy.setPublic.data(newPublic)];
                    case 3: return [4 /*yield*/, _b.apply(_a, _c.concat([_d.sent(), txParams, nonce]))];
                    case 4:
                        txHash = _d.sent();
                        console.log('TX HASH', txHash);
                        return [4 /*yield*/, dummy.waitTransactionReceipt(txHash)];
                    case 5:
                        tx1 = _d.sent();
                        console.log('TX FROM CONTRACT', tx1);
                        return [4 /*yield*/, w3.waitTransactionReceipt(txHash)];
                    case 6:
                        tx2 = _d.sent();
                        console.log('TX FROM w3', tx2);
                        return [4 /*yield*/, dummy.getPublic()];
                    case 7:
                        newPublic1 = (_d.sent()).toNumber();
                        expect(newPublic1).toEqual(newPublic);
                        newPublic2 = 789123;
                        return [4 /*yield*/, dummy.setPublic.sendTransaction.sendSigned(newPublic2, privateKey, txParams)];
                    case 8:
                        txHash = _d.sent();
                        return [4 /*yield*/, dummy.waitTransactionReceipt(txHash)];
                    case 9:
                        tx3 = _d.sent();
                        console.log('TX FROM CONTRACT', tx3);
                        return [4 /*yield*/, dummy.getPublic()];
                    case 10:
                        newPublic3 = (_d.sent()).toNumber();
                        expect(newPublic3).toEqual(newPublic2);
                        return [4 /*yield*/, w3.getTransactionCount()];
                    case 11:
                        nonce2 = _d.sent();
                        expect(nonce2).toBe(nonce + 2);
                        return [2 /*return*/];
                }
            });
        });
    });
});
//# sourceMappingURL=w3.test.js.map